
RSpec.describe "EitilCore Kernel#args_to_ivars!" do

  it "should set the given positional arguments to instance variables" do

    def test_method(a, b, c)
      args_to_ivars! :a, :c
    end

    test_method(1, "two", :three)

    expect(@a).to eq 1
    expect(@b).to be_nil
    expect(@c).to eq :three
    expect(@d).to be_nil

  end

  it "should set the given keyword arguments to instance variables" do

    def test_method(a:, b:, c:)
      args_to_ivars! :a, :c
    end

    test_method(a: 1, b: "two", c: :three)

    expect(@a).to eq 1
    expect(@b).to be_nil
    expect(@c).to eq :three
    expect(@d).to be_nil

  end

  it "should set the given local variables to instance variables" do

    a = 1
    b = "two"
    c = :three

    args_to_ivars! :a, :c

    expect(@a).to eq 1
    expect(@b).to be_nil
    expect(@c).to eq :three
    expect(@d).to be_nil

  end

end