
RSpec.describe "EitilCore Kernel#raise_error" do

  # Call specs directly on Kernel, which you would usually do implicit
  # instead of explicit, in order to escape the RSpec namespace, which has
  # it's own effects for raised errors

  it "should define a new constant, if the error class does not yet exist" do
    
    begin
      Kernel.raise_error "ThisErrorWillProbablyNotExistError"
    rescue
    end

    expect(Kernel.const_defined?('ThisErrorWillProbablyNotExistError')).to eq true

  end

  it "should call an existing constant, if the error class already exists" do
    
    expect(Kernel.const_defined?('StandardError'))
    initial_const_count = Module.constants.count

    begin
      Kernel.raise_error "StandardError"
    rescue
    end

    expect(Module.constants.count).to eq initial_const_count

  end

end