
RSpec.describe "EitilCore Date.duck_set(object)" do

  let(:date) { Date.duck_set(@object) }

  it "should return the object, if the object is a Date instance" do
    @object = Date.today
    expect(date).to eq @object
    expect(date).to be_a Date
  end

  it "should return a Date instance, if the object is a String instance" do
    @object = "2020-01-01"
    expect(@object).to be_a String 
    expect(date).to    be_a Date
  end


  it "should return a Date instance, if the object is a DateTime instance" do
    @object = DateTime.now
    expect(@object).to be_a DateTime 
    expect(date).to    be_a Date
  end


  it "should return a Date instance, if the object is a Time instance" do
    @object = Time.now
    expect(@object).to be_a Time 
    expect(date).to    be_a Date
  end


  it "should raise an error, if the object's class is not one of: String, Date, DateTime, Time" do
    @object = 2020
    expect(@object).to be_a Integer   
    begin
      error_raised = false
      date
    rescue
      error_raised = true
    end
    expect(error_raised).to eq true
  end

end


RSpec.describe "EitilCore DateTime.duck_set(object)" do

  let(:datetime) { DateTime.duck_set(@object) }

  it "should return the object, if the object is a DateTime instance" do
    @object = DateTime.now
    expect(datetime).to eq @object
    expect(datetime).to be_a DateTime
  end

  it "should return a DateTime instance, if the object is a String instance" do
    @object = "2020-01-01"
    expect(@object).to  be_a String 
    expect(datetime).to be_a DateTime
  end


  it "should return a DateTime instance, if the object is a Date instance" do
    @object = Date.today
    expect(@object).to  be_a Date 
    expect(datetime).to be_a DateTime
  end


  it "should return a DateTime instance, if the object is a Time instance" do
    @object = Time.now
    expect(@object).to  be_a Time 
    expect(datetime).to be_a DateTime
  end


  it "should raise an error, if the object's class is not one of: String, DateTime, Date, Time" do
    @object = 2020
    expect(@object).to be_a Integer   
    begin
      error_raised = false
      datetime
    rescue
      error_raised = true
    end
    expect(error_raised).to eq true
  end

end



RSpec.describe "EitilCore Time.duck_set(object)" do

  let(:time) { Time.duck_set(@object) }

  it "should return the object, if the object is a Time instance" do
    @object = Time.now
    expect(time).to eq @object
    expect(time).to be_a Time
  end

  it "should return a Time instance, if the object is a String instance" do
    @object = "20:00"
    expect(@object).to be_a String 
    expect(time).to    be_a Time
  end


  it "should return a Time instance, if the object is a Date instance" do
    @object = Date.today
    expect(@object).to be_a Date 
    expect(time).to    be_a Time
  end


  it "should return a Time instance, if the object is a DateTime instance" do
    @object = DateTime.now
    expect(@object).to be_a DateTime 
    expect(time).to    be_a Time
  end


  it "should raise an error, if the object's class is not one of: String, DateTime, Date, Time" do
    @object = 2020
    expect(@object).to be_a Integer   
    begin
      error_raised = false
      time
    rescue
      error_raised = true
    end
    expect(error_raised).to eq true
  end

end

