
# For some reason, the Kernel patches – which ruby mixes into string – are not
# available to the tests, therefore load the file manually.
load (Eitil::Root + "/eitil_core/lib/eitil_core/safe_executions/safe_send.rb")

RSpec.describe "EitilCore Object#safe_send" do

  let(:string) { "Hiya, Cowboy!" }

  it "should return the method's return value, if no error is raised" do 
    result = string.safe_send(:upcase)
    expect(result).to eq "HIYA, COWBOY!"
  end

  it "should by default return nil, if an error is raised" do
    result = string.safe_send(:this_method_does_probably_not_exist)
    expect(result).to be_nil
  end

  it "should return the specified :return_value, if an error is raised" do
    result = string.safe_send(:this_method_does_probably_not_exist, return_value: :something_else)
    expect(result).to eq :something_else
  end

end