
RSpec.describe "EitilCore String#to_filename(substitute='_')" do

  it "should substitute all spaces with, by default, lowdashes" do 
    string = "this is a filename"
    expect(string.to_filename).to eq "this_is_a_filename"
  end

  it "should substitute all spaces with, if given, the substitute argument" do 
    string = "this is a filename"
    expect(string.to_filename('-')).to eq "this-is-a-filename"
  end

  it "should substitute all slashes with, by default, lowdashes" do 
    string = "this/is/a/filename"
    expect(string.to_filename).to eq "this_is_a_filename"
  end

  it "should substitute all slashes with, if given, the substitute argument" do 
    string = "this/is/a/filename"
    expect(string.to_filename('-')).to eq "this-is-a-filename"
  end

  it "should substitute all backslashes with, by default, lowdashes" do 
    string = 'this\is\a\filename'
    expect(string.to_filename).to eq "this_is_a_filename"
  end

  it "should substitute all backslashes with, if given, the substitute argument" do 
    string = 'this\is\a\filename'
    expect(string.to_filename('-')).to eq "this-is-a-filename"
  end

end
