
RSpec.describe "EitilIntegrate::RubyXL::ApplicationExporter.new" do

  let(:exporter) do
    EitilIntegrate::RubyXL::ApplicationExporter.new(start_date: '01-01-2020', end_date: '01-03-2020')
  end

  it "should convert the string arguments :start_date and :end_date into Date objects" do
    expect(exporter.start_date).to be_a Date
    expect(exporter.end_date).to   be_a Date
  end

  it "should create a :date_range accessor" do
    expect(exporter.date_range).to       be_a Range
    expect(exporter.date_range.first).to be_a Date
  end

  it "should create a RubyXL::Workbook and RubyXL::Worksheet" do
    expect(exporter.book).to  be_a RubyXL::Workbook
    expect(exporter.sheet).to be_a RubyXL::Worksheet
  end

  it "should set the X and Y coordinates to 0" do
    expect(exporter.x).to eq 0
    expect(exporter.y).to eq 0
  end

end