
require 'pry'
require 'rails'

require 'eitil'

# Eventually implement specs for all layers.

require "eitil_core/railtie"
require "eitil_integrate/railtie"
require "eitil_wrapper/railtie"
# require "eitil_store/railtie"
# require "eitil_support/railtie"

require "eitil_core"
require "eitil_integrate"
require "eitil_wrapper"
# require "eitil_store"
# require "eitil_support"

ENV['RAILS_ENV'] ||= 'test'
require File.expand_path('dummy_app/config/environment', __dir__)

RSpec.configure do |config|

  config.expect_with :rspec do |expectations|
    expectations.include_chain_clauses_in_custom_matcher_descriptions = true
  end

  config.mock_with :rspec do |mocks|
    mocks.verify_partial_doubles = true
  end

end

# This block is added by us: the new methods .pry_describe and .pry_it
# automatically start a pry session after running the spec, allowing
# you to inspect the application's post spec state.
RSpec.configure do |config|

  config.alias_example_group_to :pry_describe, pry: true
  config.alias_example_group_to :pry_context, pry: true
  config.alias_example_to :pry_it, pry: true
  config.alias_example_to :pry_example, pry: true
  config.alias_example_to :pry_specify, pry: true

  config.after(:example, pry: true) do |example|
    require 'pry'
    binding.pry
  end

end

# This is added by us, in order to set the :documentation formatter,
# which gives quite a lot of information about the tests, as default
RSpec.configure do |config|
  config.formatter = :documentation
end


# added by us, required to prevent an error in Rack::Test
def app
  Rails.application
end

